=== debian/watch ===
version=4

# Warning: This does not apparently get the submodules: still need to use get-orig-source.sh

opts=repacksuffix=~DO_NOT_USE_THIS, \
dversionmangle=s/[+.]dfsg\d+//, \
filenamemangle=s:.*/[Mm]esh[Ll]ab:meshlab: \
    https://github.com/cnr-isti-vclab/meshlab/tags .*/Mesh[Ll]ab-(\d{4}.\d{2})\.tar\.gz
