=== debian/changelog ===
meshlab (2020.09+dfsg1-1) unstable; urgency=medium

  * New upstream version 2020.09+dfsg1
    - New plugin: global registration.
    - Closes: #975157
  * d/get-orig-source.sh: Improve
  * d/copyright:
    - Update exclusion lists.
    - Update source location.
    - Update copyright entries.
  * d/control: Add more Build-Depends for new plugins/new deps.
  * d/lintian-override: Override a false positive.
  * Rediff patches.
    - Add 0008-u3d-Use-system-zlib-jpeg-png.patch: Needed for new bundled dep
    - Drop 17_io_u3d.patch: Upstream binary dropped in favor of source, which is
      OK.
    - Drop 0007-Install-icon-to-correct-pixmaps-dir.patch: Incorporated
      upstream.
    - Add 0009-cmake-Search-for-use-Qt5Qml-in-a-more-graceful-absen.patch: Fixes
      build error in absence of qt declarative
    - Add 0010-build-Use-C99-where-available-for-large-file-support.patch: Fixes
      build warning.

 -- Ryan Pavlik <ryan@ryanpavlik.com>  Tue, 01 Dec 2020 13:35:09 -0600
